# ifndef lint
static char	Sccs_id [] = "@(#)proc.c	1.3	(Achilles Voliotis)	(7/12/88)";
# endif

# include	"fsh.h"

/*
 * substr(s1, s2): returns 1 if s1 is a substring of s2, zero otherwise
 */

substr (s1, s2)
	register char  *s1, *s2;
{
	register int    k = strlen (s1);

	while (*s2) {
		if (strncmp (s1, s2, k) == 0)
			return (1);
		s2++;
	}
	return (0);
}


/*
 * setenv (var, value): sets the environment variable `var' to `value'
 */

setenv (var, value)
	register char  *var, *value;
{
	static char    *sbuf;
	extern char   **environ;
	extern char    *malloc ();

	register char **env = environ;
	register int    k;

	sbuf = malloc (256);
	k = strlen (var);
	while (**env && (strncmp (var, *env, k) != 0))
		env++;
	sprintf (sbuf, "%s=%s", var, value);
	*env = sbuf;
}


/*
 * systemmes(): prints a random message
 */

systemmes ()
{
	register int    j = rnd (NMSG);

	printf ("\n%s: ", eqs (buf, "!!", 2) ? lastcomm : buf);
	if (j == 0)
		j = rnd (22) + 1;
	printf (mesg[j], rnd (9 * j), rnd (21 * j), rnd (344 * j), rnd (2221));
	printf ("\n\n");
}


/*
 * bin_search(s): search if s is a unix command
 */

int 
bin_search (s)
	register char  *s;
{
	register int    c, mid, k;
	register int    low = 0, high = NCMDS - 1;

	k = strlen (s);
	while (low <= high) {
		mid = (low + high) >> 1;
		if ((c = strncmp (s, cmd[mid].name, k)) < 0)
			high = mid - 1;
		else if (c > 0)
			low = mid + 1;
		else
			return (cmd[mid].code);
	}
	return (-1);
}

/*
 * printprompt(): prints the prompt replacing `!' with the
 *		  command number.
 */

printprompt ()
{
	register char  *s = prompt;

	while (*s) {
		if (*s != '!')
			putchar (*s);
		else
			printf ("%d", commandno);
		s++;
	}
}


/*
 * erase_char (c) : erase the char c
 */

erase_char (c)
unsigned char c;
{
	register int j, t;

	t = strlen (unctrl (c));
	for (j = 0; j < t; j++)
		printf ("\b \b");
}


/*
 * getcom(): read a command line
 */

getcom ()
{
	char            st[256];
	register int    i, j, t, c;
	register char  *s;

	printprompt ();
	for (i = 0; i < 256 && (c = getchar ()) != EOF;) {
		if (c == erasechar ()) {
			if (i > 0) 
				erase_char (st[i--]);
			else
				putchar ('\07');
		} else if (c == killchar ()) {
			if (i > 0) 
				while (i) 
					erase_char (st[i--]);
		} else if (c == CTRL(W)) {	/* Word erase */
			if (i > 0) {
				while (i && isspace (st[i-1]))
					erase_char (st[i--]);
				while (i && !isspace (st[i-1]))
					erase_char (st[i--]);
				while (i && isspace (st[i-1]))
					erase_char (st[i--]);
			}
		} else if (c == '\n' || c == '\r') {
			printf ("\n\r");
			st[i++] = c;
			break;
		} else if (c == CTRL(D)) {
			sprintf (buf, "\04");
			return (2);
		} else {
			if (c == '\t') {
				j = (i + 8) & ~07;
				while (i < j) {
					putchar (' ');
					st[i++] = ' ';
				}
			} else {
				s = unctrl (c);
				st[i++] = c;
				printf ("%s", s);
			}
		}
	}
	st[i] = 0;
	t = 0;
	if (commandno > 1 && !eqs (command, "!!", 2))
		strcpy (lastcomm, command);
	strcpy (command, st);
	if (command[i - 1] == '\n' || command[i - 1] == '\r')
		command[i - 1] = '\0';
	while (st[t] == ' ')
		t++;
	for (c = t; st[c] && st[c] != ' ' && st[c] != '\n' && st[c] != '\r'; c++);
	st[c] = 0;
	strcpy (buf, st + t);
	return (i);
}


/*
 * funnymes(s): execute the program s which is supposed that prints
 *		a funny message
 */

funnymes (s)
	register char  *s;
{
	putchar ('\n');
	run (s);
	putchar ('\n');
	fflush (stdout);
};


/*
 * tomb(): print the users's tombstone
 */

tomb ()
{
	register int    i;
	register struct passwd *pass;
	struct passwd  *getpwuid ();

	pass = getpwuid (getuid ());
	for (i = 0; i < NLINES; i++) {
		if (i == 7)
			printf (tombpic[7], pass->pw_name);
		else
			printf (tombpic[i]);
		putchar ('\n');
	}

}


/*
 * run (s): execute the command string s
 */

run (s)
	register char  *s;
{
# ifdef BSD
	union wait      status;

# else
	unsigned        status;

# endif
	extern char    *getenv ();
	extern int      onintr ();

	if (substr ("kill", s)) {
		tomb ();
		return;
	}
	if (substr ("csh", s) || substr ("ksh", s) || substr ("sh", s)
	    || substr ("su", s)) {
		systemmes ();
		return;
	}
	if (eqs (s, "cd", 2)) {
		s += 2;
		while (*s == ' ' || *s == '\t')
			s++;
		if (*s)
			chdir (s);
		else
			chdir (getenv ("HOME"));
		return;
	}
	if (fork () == 0) {
		signal (SIGINT, SIG_DFL);
		signal (SIGQUIT, SIG_DFL);
		signal (SIGHUP, SIG_DFL);
# ifdef BSD
		signal (SIGTSTP, SIG_DFL);
		nocbreak ();
# else
		reset_shell_mode ();
# endif
		execlp (shell, "fsh",
		    (strcmp (shell, "/bin/sh") == 0) ? "-c" : "-cf", s, NULL);
	} else {
		signal (SIGINT, SIG_IGN);
		signal (SIGQUIT, SIG_IGN);
		signal (SIGHUP, SIG_IGN);
# if defined(SIGTSTP) || defined(BSD)
		signal (SIGTSTP, SIG_IGN);
# endif
		wait (&status);
		signal (SIGINT, onintr);
		signal (SIGQUIT, onintr);
		signal (SIGHUP, onintr);
# if defined(SIGTSTP) || defined(BSD)
		signal (SIGTSTP, onintr);
		cbreak ();
# else
		reset_prog_mode ();
# endif
	}
}


/*
 * onintr(): Process interrupts
 */

int 
onintr ()
{
	register int    i, j, k;

	printf ("\n\nInterrupt !!!\n");
	k = rnd (15) + 1;
	for (i = 0; i < k; i++) {
		if (isprint (j = rnd (85) + ' '))
			buf[i] = j;
	}
	buf[i] = '\0';
	systemmes ();
	longjmp (sjbuf);
}
